dofile("sa2lua/bitwise.lua")

function num2hex(num) -- http://snipplr.com/view/13086/number-to-hex/
	if num ~= nil then
		local hexstr = '0123456789ABCDEF'
		local s = ''
		while num > 0 do
			local mod = math.fmod(num, 16)
			s = string.sub(hexstr, mod+1, mod+1) .. s
			num = math.floor(num / 16)
		end
		if s == '' then s = '0' end
		return s
	else
		return ""
	end
end

function OpenCaptionAddress(sender)
	local addr = tonumber(control_getCaption(sender), 16)
	if addr ~= nil then
		local memview = getMemoryViewForm()
		local hexview = memoryview_getHexadecimalView(memview)
		hexadecimalview_setTopAddress(hexview, addr)
		form_show(memview)
	end
end

function LoadBinaryFile(filename, address)
	local file = io.open(filename, "rb")
	if file == nil then
		print("Error opening file "..filename.."!")
		return nil
	end
	local data = file:read("*all")
	local length = string.len(data)
	file:close()
	for i=1,length do
		local addr = address - 1 + i
		writeBytes(addr, string.byte(data, i))
	end
	return length
end

function string:split(delimiter)
	-- This function was written by krsk9999 on Stack Overflow
	-- http://stackoverflow.com/questions/1426954/split-string-in-lua
	local result = { }
	local from  = 1
	local delim_from, delim_to = string.find( self, delimiter, from  )
	while delim_from do
		table.insert( result, string.sub( self, from , delim_from-1 ) )
		from  = delim_to + 1
		delim_from, delim_to = string.find( self, delimiter, from  )
	end
	table.insert( result, string.sub( self, from  ) )
	return result
end